
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>介绍Python的@property装饰器的用法 / iVAN</title>

    <meta name="description" content="介绍Python的@property装饰器的用法   这篇文章主要介绍了介绍Python的@property装饰器的用法,是Python学习进阶中的重要知识,代码基于Python2.x版本,需要的朋友可以参考下 在绑定属性时,如果我们直接把属性暴露出去,虽然写起来很简单,但是,没办法检查参数,导致可以把成绩随便改: ? 1 2 s = Student() s.score = 9999 这显然不合逻辑.为了限制score的范围,可以通过一个set_score()方法来设置成绩,再通过一个get_score()来获取成绩,这样,在set_score">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">介绍Python的@property装饰器的用法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p> 　　这篇文章主要介绍了介绍Python的@property装饰器的用法,是Python学习进阶中的重要知识,代码基于Python2.x版本,需要的朋友可以参考下</p>
<p>　　在绑定属性时，如果我们直接把属性暴露出去，虽然写起来很简单，但是，没办法检查参数，导致可以把成绩随便改：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2
            </td>
<td>
<p>s = Student()<br />
            s.score = 9999</p>
</td>
</tr>
</tbody>
</table>
<p>　　这显然不合逻辑。为了限制score的范围，可以通过一个set_score()方法来设置成绩，再通过一个get_score()来获取成绩，这样，在set_score()方法里，就可以检查参数：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3<br />
            4<br />
            5<br />
            6<br />
            7<br />
            8<br />
            9<br />
            10<br />
            11
            </td>
<td>
<p>class Student(object):<br />
             <br />
            def get_score(self):<br />
            return self._score<br />
             <br />
            def set_score(self, value):<br />
            if not isinstance(value,  int):<br />
            raise ValueError('score must be an integer!')<br />
            if value &lt; 0 or value &gt; 100:<br />
            raise ValueError('score must between 0 ~ 100!')<br />
            self._score  = value</p>
</td>
</tr>
</tbody>
</table>
<p>　　现在，对任意的Student实例进行操作，就不能随心所欲地设置score了：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3<br />
            4<br />
            5<br />
            6<br />
            7<br />
            8
            </td>
<td>
<p>&gt;&gt;&gt; s =  Student()<br />
            &gt;&gt;&gt; s.set_score(60) # ok!<br />
            &gt;&gt;&gt; s.get_score()<br />
            60<br />
            &gt;&gt;&gt; s.set_score(9999)<br />
            Traceback (most recent call last):<br />
            ...<br />
            ValueError: score must between 0 ~  100!</p>
</td>
</tr>
</tbody>
</table>
<p>　　但是，上面的调用方法又略显复杂，没有直接用属性这么直接简单。</p>
<p>　　有没有既能检查参数，又可以用类似属性这样简单的方式来访问类的变量呢?对于追求完美的Python程序员来说，这是必须要做到的!</p>
<p>　　还记得装饰器(decorator)可以给函数动态加上功能吗?对于类的方法，装饰器一样起作用。Python内置的@property装饰器就是负责把一个方法变成属性调用的：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3<br />
            4<br />
            5<br />
            6<br />
            7<br />
            8<br />
            9<br />
            10<br />
            11<br />
            12<br />
            13
            </td>
<td>
<p>class Student(object):<br />
             <br />
            @property<br />
            def score(self):<br />
            return self._score<br />
             <br />
            @score.setter<br />
            def score(self, value):<br />
            if not isinstance(value,  int):<br />
            raise ValueError('score must be an integer!')<br />
            if value &lt; 0 or value &gt; 100:<br />
            raise ValueError('score must between 0 ~ 100!')<br />
            self._score  = value</p>
</td>
</tr>
</tbody>
</table>
<p>　　@property的实现比较复杂，我们先考察如何使用。把一个getter方法变成属性，只需要加上@property就可以了，此时，@property本身又创建了另一个装饰器@score.setter，负责把一个setter方法变成属性赋值，于是，我们就拥有一个可控的属性操作：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3<br />
            4<br />
            5<br />
            6<br />
            7<br />
            8
            </td>
<td>
<p>&gt;&gt;&gt; s =  Student()<br />
            &gt;&gt;&gt; s.score = 60 #  OK，实际转化为s.set_score(60)<br />
            &gt;&gt;&gt; s.score #  OK，实际转化为s.get_score()<br />
            60<br />
            &gt;&gt;&gt; s.score = 9999<br />
            Traceback (most recent call last):<br />
            ...<br />
            ValueError: score must between 0 ~  100!</p>
</td>
</tr>
</tbody>
</table>
<p>　　注意到这个神奇的@property，我们在对实例属性操作的时候，就知道该属性很可能不是直接暴露的，而是通过getter和setter方法来实现的。</p>
<p>　　还可以定义只读属性，只定义getter方法，不定义setter方法就是一个只读属性：</p>
<p>　　?</p>
<table>
<tbody>
<tr>
<td>
            1<br />
            2<br />
            3<br />
            4<br />
            5<br />
            6<br />
            7<br />
            8<br />
            9<br />
            10<br />
            11<br />
            12<br />
            13
            </td>
<td>
<p>class Student(object):<br />
             <br />
            @property<br />
            def birth(self):<br />
            return self._birth<br />
             <br />
            @birth.setter<br />
            def birth(self, value):<br />
            self._birth  = value<br />
             <br />
            @property<br />
            def age(self):<br />
            return 2014 - self._birth</p>
</td>
</tr>
</tbody>
</table>
<p>　　上面的birth是可读写属性，而age就是一个只读属性，因为age可以根据birth和当前时间计算出来。</p>
<p>　　小结</p>
<p>　　@property广泛应用在类的定义中，可以让调用者写出简短的代码，同时保证对参数进行必要的检查，这样，程序运行时就减少了出错的可能性。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 11:14:01</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e5%b1%9e%e6%80%a7/" title="属性">属性</a>, <a href="https://www.iamivan.net/tag/value/" title="value">value</a>, <a href="https://www.iamivan.net/tag/property/" title="property">property</a>, <a href="https://www.iamivan.net/tag/score/" title="score">score</a>, <a href="https://www.iamivan.net/tag/self/" title="Self">Self</a>, <a href="https://www.iamivan.net/tag/python-%e8%af%bb%e5%86%99/" title="python 读写">python 读写</a>, <a href="https://www.iamivan.net/tag/isinstance/" title="isinstance">isinstance</a>, <a href="https://www.iamivan.net/tag/%e8%a3%85%e9%a5%b0%e5%99%a8/" title="装饰器">装饰器</a>, <a href="https://www.iamivan.net/tag/python%e4%bb%a3%e7%a0%81%e6%a3%80%e6%9f%a5/" title="python代码检查">python代码检查</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>介绍Python的@property装饰器的用法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z729vRp.html" rel="bookmark">Python中的装饰器用法详解&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Python中的装饰器用法.分享给大家供大家参考.具体分析如下: 这里还是先由stackoverflow上面的一个问题引起吧,如果使用如下的代码: 复制代码 代码如下: @makebold @makeitalic def say():    return &quot;Hello&quot; 打印出如下的输出: &lt;b&gt;&lt;i&gt;Hello&lt;i&gt;&lt;/b&gt; 你会怎么做?最后给出的答案是: 复制代码 代码如下: def makebold(fn):    			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgwrPmM.html" rel="bookmark">Python中的装饰器用法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				来源:http://www.jb51.net/article/59867.htm 来源:http://blog.csdn.net/mdl13412/article/details/22608283 这篇文章主要介绍了Python中的装饰器用法,以实例形式详细的分析了Python中的装饰器的使用技巧及相关注意事项,具有一定参考借鉴价值,需要的朋友可以参考下 本文实例讲述了Python中的装饰器用法.分享给大家供大家参考.具体分析如下: 这里还是先由stackoverflow上面的一个问题引起吧,如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGrK6vp.html" rel="bookmark">详解Python中的装饰器、闭包和functools的教程&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				装饰器(Decorators) 装饰器是这样一种设计模式:如果一个类希望添加其他类的一些功能,而不希望通过继承或是直接修改源代码实现,那么可以使用装饰器模式.简单来说Python中的装饰器就是指某些函数或其他可调用对象,以函数或类作为可选输入参数,然后返回函数或类的形式.通过这个在Python2.6版本中被新加入的特性可以用来实现装饰器设计模式. 顺便提一句,在继续阅读之前,如果你对Python中的闭包(Closure)概念不清楚,请查看本文结尾后的附录,如果没有闭包的相关概念,很难恰当的理解P			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYByv5p.html" rel="bookmark">python &commat;age&period;setter 装饰器 怎么用p&period;age&equals;1调用不了</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 python @age.setter 装饰器 怎么用p.age=1调用不了 #源码: class Person: def init(self,name,age): print('gouzao') self.__name=name self.__age=age @property def age(self): print('thisis get') return self.__age @age.setter def age(self,value): print('jinlaileme')			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnRj40p.html" rel="bookmark">Python深入05 装饰器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Python深入05 装饰器 作者:Vamei 出处:http://www.cnblogs.com/vamei 欢迎转载,也请保留这段声明.谢谢!   装饰器(decorator)是一种高级Python语法.装饰器可以对一个函数.方法或者类进行加工.在Python中,我们有多种方法对函数和类进行加工,比如在Python闭包中,我们见到函数对象作为某一个函数的返回结果.相对于其它方式,装饰器语法简单,代码可读性高.因此,装饰器在Python项目中有广泛的应用. 装饰器最早在Python 2.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNQxxp.html" rel="bookmark">举例讲解Python中装饰器的用法&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于函数也是一个对象,而且函数对象可以被赋值给变量,所以,通过变量也能调用该函数. &gt;&gt;&gt; def now(): ... print '2013-12-25' ... &gt;&gt;&gt; f = now &gt;&gt;&gt; f() 2013-12-25 函数对象有一个__name__属性,可以拿到函数的名字: &gt;&gt;&gt; now.__name__ 'now' &gt;&gt;&gt; f.__name__ 'now' 现在,假设我们要增强now()函数的功能,比			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQeL5p.html" rel="bookmark">理解Python中的装饰器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章先由stackoverflow上面的一个问题引起吧,如果使用如下的代码: @makebold @makeitalic def say(): return &quot;Hello&quot; 打印出如下的输出: &lt;b&gt;&lt;i&gt;Hello&lt;i&gt;&lt;/b&gt; 你会怎么做?最后给出的答案是: def makebold(fn): def wrapped(): return &quot;&lt;b&gt;&quot; + fn() + &quot;&lt;/b&gt;&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjwWo8M.html" rel="bookmark">python闭包以及装饰器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通俗的定义:如果在一个内部函数里,对在外部作用域(但不是在全局作用域)的变量进行引用,那么内部函数就被认为是闭包(closure).它只不过是个&quot;内层&quot;的函数,由一个名字(变量)来指代,而这个名字(变量)对于&quot;外层&quot;包含它的函数而言,是本地变量; 1 #示例一: 2 #!/usr/bin/python 3 #encoding=utf-8 4 5 def add_a(num1): 6 print &quot;num1:%d&quot; % num1 7 def add			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ1KEob.html" rel="bookmark">python中的装饰器详解&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在了解装饰器的之前一定要先了解函数作为参数传递, 什么是函数内嵌,请参考我之前写的博客函数简介 因为在python里面,函数也是对象,也可以作为参数进行传递.python装饰器本质也是一种特殊函数,它接收的参数是函数对象,然后动态地函数参数添加额外的功能,而不用修改原有的函数对象.python装饰器传入的参数是函数,返回的值也是函数! python装饰器思想有点类似设计模式的装饰模式, 其意图是动态地给函数对象添加额外的功能.比如像增加日志打印的功能,有点面向切面编程(AOP)的感觉.装饰器语法			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyDy5b.html" rel="bookmark" class="title">PHP版的GBK版的中文简体、繁体互转函数</a>
					<div>
						昨天上GOOGLE找PHP的简体.繁体互转函数.转载文章倒是很多,但字符表却下不下,不能用..无奈只能自己写了,分享给有需要的人吧.注意这是GBK版的!水平有限,接触PHP也不多,不足在所难免 以下是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEq3Zb.html" rel="bookmark" class="title">Flash与后台编码问题解决新方案</a>
					<div>
						编码|后台|解决|问题     在Flash MX的时候开始,就经常有人问为什么Flash载入的中文会是乱码?后来大家都用了System.useCodePage=true;去解决这个问题.可能大家都已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8nJPb.html" rel="bookmark" class="title">实例分析清障车站排名长期第一位置的原因</a>
					<div>
						说道做优化,站长们无非的目的都是想把关键词做至第一,且长期稳定,搜索指数少的词大家也许不怕,排名可能会很容易做至第一并稳定,但是对于一个超高竞争难度的词如何在短时间内升至第一并长期稳定下来,相信部分站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PdV6M.html" rel="bookmark" class="title">Java求数组中连续n个元素使其和最大</a>
					<div>
						给定一个数组,求出数组中连续的一些元素使其和的值最大.如果所有元素都为正数,显然整个数组即为所求的.如果所有元素的值为负数,则所求的最大值为0. 这是在编程珠玑上看到的,其时间复杂度由O(n3)减为O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPN5EDb.html" rel="bookmark" class="title">Photoshop制作蓝色光束背景壁纸</a>
					<div>
						很多光束壁纸看上去非常不错,各种不同形状的光束叠加到一起,梦幻并带有一定的层次感,感觉非常舒服.下面的效果简单介绍这类壁纸的制作方法.其实用到的工具非常简单,仅画笔和钢笔工具.只要掌握了其中的方法,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxP1L0M.html" rel="bookmark" class="title">PS羽化图片边缘方法</a>
					<div>
						  PS羽化图片边缘方法          为了让处理的图片更美观,我们抠图之后都会进行边缘的羽化,这样能让图片更好的嵌入另一张图片.那么用PS如何羽化图片边缘?下面小编就为大家详细介绍一下,来看看吧 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2q0Nb.html" rel="bookmark" class="title">PS制作可口诱人的巧克力蛋糕2012文字教程</a>
					<div>
						教程介绍用PS制作出可口诱人的巧克力蛋糕2012文字效果,是不是看到都想吃一口啊?制作这个字体主要用到图层样式,喜欢的同学赶快一起来学习一下吧! 字体完成效果: 1.新建文件. 2.输入一个圆滑的字体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baljNwz.html" rel="bookmark" class="title">用Word2007为文档添加文字水印和图片水印</a>
					<div>
						一.用Word2007为文档添加文字水印 在word 2007中打开需要添加水印的文档.在&quot;页面布局&quot;菜单下选择&quot;水印&quot;,我们可以看到word 2007为我们提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN18Dyb.html" rel="bookmark" class="title">js如何调用qq互联api实现第三方登录</a>
					<div>
						 这篇文章主要介绍了js如何调用qq互联api实现第三方登录,需要的朋友可以参考下 qq互联js SDK:http://wiki.connect.qq.com/js_sdk%E4%BD%BF%E7%9 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWAGRb.html" rel="bookmark" class="title">MAC系统中各个文件夹介绍</a>
					<div>
						  Mac OS X,这是一个基于UNIX核心的系统,增强了系统的稳定性.性能以及响应能力.它能通过对称多处理技术充分发挥双处理器的优势,提供无与伦比的2D.3D和多媒体图形性能以及广泛的字体支持和集 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72B04p.html" rel="bookmark" class="title">CF游戏的截图工具使用说明</a>
					<div>
						对于截图操作想来经常使用win7系统的用户都不会感到陌生.我们玩CF游戏的时候,有时会把自己比较好的游戏记录截图下来.可是当我们想要看这些截图的时候却怎么也无法找到.那么有什么办法可以查找到这些图片呢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1exdb.html" rel="bookmark" class="title">修改XP系统欢迎界面的方法</a>
					<div>
						  1.首先,我们需要自行去下载一张图片,自己觉得好看的,需要用来设置为欢迎界面的图片,但是图片的大小是有标准的,必须要小于256KB,如果下载的图片过大,大家可以使用相应的工具来修改. 2.之后,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRnNlp.html" rel="bookmark" class="title">杀鸡小问题，要请大牛人用刀</a>
					<div>
						问题描述 http://tieba.baidu.com/f?kz=425635633不能删除,回复,想知道破解方法.和原理谢谢各位大大.嘿嘿嘿 解决方案 解决方案二:不知道解决方案三:不知道...顶. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlB5xqz.html" rel="bookmark" class="title">Android pdf viewer在android studio应用问题说明详解&lowbar;Android</a>
					<div>
						之前一直是做.NET开发的,最近需要弄一个新闻app,能力有限,只能借助HTML5 WebAPP+android studio来完成这项工作. android studio主要用WebView来加载发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPvv0p.html" rel="bookmark" class="title">纹理贴图 内存-从内存DC中获取截取桌的面图像用于纹理贴图时，获取的内容一直是空的怎么回事</a>
					<div>
						问题描述 从内存DC中获取截取桌的面图像用于纹理贴图时,获取的内容一直是空的怎么回事 我的程序是这样的,获取桌面图像,传到内存DC,在内存DC中取出图像,生成纹理(或其他处理操作,比如融合),进行纹理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwkydp.html" rel="bookmark" class="title">请问环信的sdk中有判断当前网络是wifi&comma;3g&comma;4g这样状态的api吗？</a>
					<div>
						问题描述 解决方案 SDK有提供判断网络类型的接口,但是需要您实现一下,给您发个链接您先看看http://docs.easemob.com/doku.p ... ledoc        由EMDev ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr1R1M.html" rel="bookmark" class="title">dwr-Ajax开源框架</a>
					<div>
						dwr全称Direct Web Remoting原理将java代码转化成js对象,实现跨域访问 web.xml &lt;?xml version=&quot;1.0&quot; encoding=&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA69GM.html" rel="bookmark" class="title">&lbrack;Docker系列&CenterDot;2&rsqb; 搭建基于Docker的Nginx服务器</a>
					<div>
						docker命令别名 ~/.bashrc # .bashrc alias d=&quot;sudo docker&quot; docker的nginx工作目录 /home/erichan/d/ngin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myd104b.html" rel="bookmark" class="title">大型知名网站频遭黑客挂马</a>
					<div>
						本周瑞星共截获166万个挂马网址.挂马网站针对的都是一些大型的知名网站,中华英才网.中国书画苑.四川新闻网的部分页面被黑客挂马. 近期关注病毒:MS08-067漏洞病毒变种MD(Hack.Exploi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40BZ9z.html" rel="bookmark" class="title">请教：如何在一个已有的aspx&plus;cs里添加自己的js呢？</a>
					<div>
						问题描述 aspx里用imageButton作为提交按钮,后台cs实现校验等功能.现在我希望在提交按钮被按下时能执行一些js,应该怎么作呢?实在没办法改cs了,没环境.... 解决方案 解决方案二:为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE40yqz.html" rel="bookmark" class="title">消息提示音和震动怎么设置？现在收到消息也没有提示音和震动</a>
					<div>
						问题描述 解决方案 在didreceivemessage回调方法中调用demo中的这个方法playSoundAndVibration,就有震动和提示音了.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkP30M.html" rel="bookmark" class="title">ie8选择兼容窗口后，css的background-image&colon;url就无法显示图片</a>
					<div>
						问题描述 ie8选择兼容窗口后,css的background-image:url就无法显示图片 ie8选择兼容窗口后,css的background-image:url就无法显示图片,取消兼容后显示正常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyBqXz.html" rel="bookmark" class="title">JasperReports发布新版本：JasperReports-5&period;1&period;0</a>
					<div>
						  下载地址: http://sourceforge.net/projects/jasperreports/files/jasperreports/JasperReports%205.1.0/   我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWDZEM.html" rel="bookmark" class="title">C&num;中正则表达式使用介绍</a>
					<div>
						摘要:本文给出了在C#下利用正则表达式实现字符串搜索功能的方法,通过对.NET框架下的正则表达式的研究及实例分析,总结了正则表达式的元字符.规则.选项等. 关键字:正则表达式.元字符.字符串.匹配 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjoEQM.html" rel="bookmark" class="title">identifier标签语句</a>
					<div>
						摘抄自 &quot;犀牛书&quot; (之前挑重点看的,这下不小心翻到了这个,看来有时间还是得从头到尾过一遍,吼吼) Only break and continue can use identifi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RaKnz.html" rel="bookmark" class="title">delphi paradox-delphi 连接现有paradox的数据库</a>
					<div>
						问题描述 delphi 连接现有paradox的数据库 现在我有一个需要读取操作的paradox数据库,delphi7是新装,需要什么操作才可以把这个数据库连接好? 解决方案 http://bbs.c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z440Jrz.html" rel="bookmark" class="title">Python开发WebService系列教程之REST&comma;web&period;py&comma;eurasia&comma;Django&lowbar;python</a>
					<div>
						在Bioinformatics(生物信息学)领域,WebService是很重要的一种数据交换技术,未来必将更加重要.目前EBI所提供的WebService就分别有SOAP和REST两种方式的服务,不管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8GlWb.html" rel="bookmark" class="title">营销案例：邀请网民全员参与的众包活动</a>
					<div>
						众包(crowdsourcing)是一种新的参与型营销方式,也可以说是另一种形式的客户关系管理,但它同样也可以作为一种数字营销战术.这一概念在维基百科的运作中体现得淋漓尽致,现在这一概念也在各种网络营 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1DEjKb.html" rel="bookmark" class="title">小说下载阅读器使用技巧及常见问题汇总</a>
					<div>
						软件下载:小说下载阅读器 v2.0中文版 1.如何使用阅读器下载小说? 方法一:在搜索框中输入你想下载的小说名,有搜索结果列出来后,选择需要的小说,点击&quot;下载&quot;http://www ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6YAJLb.html" rel="bookmark" class="title">极度简约 最小 Linux 发行版 Tiny Core Linux 7&period;1 发布</a>
					<div>
						感谢Linux Story的投递 Tiny Core Linux 是一个极度简约但是也高度可扩展的 GNU/Linux 发行版,其之精简甚至可以小到只有 10MB 大小,昨天 5月23日刚刚发布的 T ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
